import { OnInit, EventEmitter, OnDestroy, ElementRef, TemplateRef } from '@angular/core';
import { FormControl } from '@angular/forms';
import { Subscription } from 'rxjs/Subscription';
import { RequestService } from '../services/request.service';
import { Router } from '@angular/router';
export declare class LivesearchComponent implements OnInit, OnDestroy {
    private requestService;
    private router;
    private elRef;
    searchUrl: string;
    localSource: Array<any>;
    template: TemplateRef<any>;
    textOptions: any;
    searchOptions: any;
    onSelect: EventEmitter<{}>;
    showEmptyMessage: boolean;
    seeAllParams: any;
    searchResult: any[];
    loading: boolean;
    visible: boolean;
    loadingSubscription: Subscription;
    searchInput: FormControl;
    defaultSearchOptions: {
        searchParam: string;
        interval: number;
        limit: number;
        seeAllUrl: any;
        seeAllParams: {};
        seeAllPassSearchValue: boolean;
    };
    defaultTextOptions: {
        seeAll: string;
        noResults: string;
        placeholder: string;
    };
    doumentClicked(target: any): void;
    constructor(requestService: RequestService, router: Router, elRef: ElementRef);
    ngOnInit(): void;
    private init();
    getSearchParams(): any;
    keyPressedOnSearchInput(event: KeyboardEvent): void;
    keyPressedOnSearchResult(event: KeyboardEvent): void;
    configureSearchService(): void;
    searchResultSelected(selectedItem: any): void;
    localSourceHandler(query: string): void;
    searchFinished(results: Array<any>): void;
    clearSearch(): void;
    inputFocused(): void;
    navigateToSeeAll(): void;
    ngOnDestroy(): void;
}
